/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 11.8 (Uniform-Ball, p. 255)
 *
 * this file: algo11_08.c
 *
 * For a demo how to use this algorithm see the file "demo_algo11_08.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"
#include "algo.h"

void generator11_08(int d, double x[])
/* 
 * Algorithm 11.8 (Uniform-Ball, p. 255)
 * generates a random vector in the ball B^d
 * d ... length of the generated vectors
 * x ... is the array to hold the generated vector     
 */
{     int i;
      double r,u; 

/*1*/ generator11_06(d,x);
/*2*/ u = uniform();
/*3*/ r=exp(log(u)/d);
/*4*/ for(i=1;i<=d;i++) x[i]*=r;
}


