/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 11.10 (Uniform-Simplex, p. 257)
 *
 * this file: algo11_10.c
 *
 * For a demo how to use this algorithm see the file "demo_algo11_10.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"
#include "algo.h"

void generator11_10(int d, double v[],double x[])
/* 
 * Algorithm 11.10 (Uniform-Simplex, p. 257)
 * generates a vector uniform distributed over the simplex with vertices v_i
 * d ... length of the generated vectors (must be smaller than 30)
 * v ... is the array that contains the (d+1) vertices stored in a
 *       sequential way.
 * x ... is the array to hold the generated vector     
 */
{     int i,j;
      double s[32]; 
/*1*/ generator11_09(d,s);
      for(j=1;j<=d;j++){
	x[j] = 0.;
	for(i=1;i<=d+1;i++){
/*2*/	  x[j]+=s[i]*v[i*(d+1)+j];
	}
      }
}



